from src.zero.agent import ZeroAgent
from src.GOPS.prompts import GOPS_RULES_2
from src.GOPS.ground_truth_models import ObservedState, ground_truth_models
from src.llm.model import OpenAIModel
from src.searchlight.gameplay.simulators import GameSimulator
import inspect

# create game simulator
simulator = GameSimulator(**ground_truth_models)

# create agents
agents = {
0: ZeroAgent({0,1}, 0, True, GOPS_RULES_2, inspect.getsource(ObservedState), OpenAIModel("gpt-4o-mini")),
1: ZeroAgent({0,1}, 1, True, GOPS_RULES_2, inspect.getsource(ObservedState), OpenAIModel("gpt-4o-mini")),
}

# run game
simulator.simulate_game(agents, display=True)


# test_method = """
# import numpy as np
# def test_method():
#     return np.random.rand()
# """

# exec(test_method)
# a = locals()['test_method']()
# print(a)